﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace _799165_Add_Record_If_Available_MVC.Controllers
{
    public class HomeController : Controller
    {
        // GET: /Home/
        public ActionResult Index()
        {
            TempData["PartBookDDL"] = GetPartBooks();
            TestEntities entities = new TestEntities();
            TempData["Records"] = entities.CategoryDetails.ToList();
            return View();
        }

        [HttpPost]
        public ActionResult Index(int txtNumberNeeded, string PartBook)
        {
            TempData["PartBookDDL"] = GetPartBooks();
            TestEntities entities = new TestEntities();
            List<SelectListItem> positionList = GetPartBooks();
            string category = positionList.Find(p => p.Value == PartBook).Text;
            int lastNumber = 0;
            if (entities.CategoryDetails.Where(x => x.Category == category).Count() > 0)
            {
                lastNumber = Convert.ToInt32(entities.CategoryDetails.Where(x => x.Category == category).Max(x => x.Last4Numbers));
                lastNumber++;
            }
            for (int i = lastNumber; i < txtNumberNeeded + lastNumber; i++)
            {
                if (i != 9999)
                {
                    entities.CategoryDetails.AddObject(new CategoryDetail { Category = category, Last4Numbers = i.ToString() });
                    entities.SaveChanges();
                }
            }

            TempData["Records"] = entities.CategoryDetails.ToList();
            return View("Index");
        }

        // Get list from database.
        public List<SelectListItem> GetPartBooks()
        {
            List<SelectListItem> partBooks = new List<SelectListItem>();
            partBooks.Add(new SelectListItem { Text = "Category 1", Value = "1" });
            partBooks.Add(new SelectListItem { Text = "Category 2", Value = "2" });
            partBooks.Add(new SelectListItem { Text = "Category 3", Value = "3" });
            partBooks.Add(new SelectListItem { Text = "Category 4", Value = "4" });

            return partBooks;
        }
    }
}
